// This is a part of the GWC Library
// Copyright (C) 2001-2002 Aircom software
// All rights reserved.
//
// This source code can be used, distributed or modified
// free of charge only if this header copyright is not removed.
// In other cases, contact us at:
// web:   http://www.aircom.org
// email: info@aircom.org
//

#ifndef __GWCCOLORCOMPONENTSET_H
#define __GWCCOLORCOMPONENTSET_H

#include "GWCCCELink.h"
#include <vector>

class GWCColorComponentEditCtrl;

typedef std::vector<GWCColorComponentEditCtrl*> CompVector;

class GWCCCECTRL_LINKAGE GWCColorComponentSet  
{
	// Construction
	public:
		GWCColorComponentSet() {}
		virtual ~GWCColorComponentSet() {}

	// Attributes
	protected:
		// Hue component of the color maintained by this object.
		BYTE m_hue;

		// Saturation component of the color maintained by this object.
		BYTE m_saturation;

		// Light component of the color maintained by this object.
		BYTE m_light;

		// RGB components of the color maintained by this object.
		COLORREF m_color;

		// The set of all component controls related to the color maintained by this object.
		CompVector m_components;

	// Operations
	public:
		COLORREF GetColor();
		void GetColor(BYTE* hue, BYTE* sat, BYTE* light);
		void GetColor(CString& str);
		void SetColor(COLORREF color);
		void SetColor(BYTE hue, BYTE sat, BYTE light);
		void RegisterComponentCtrl(GWCColorComponentEditCtrl& wnd);
		void OnComponentChanged(GWCColorComponentEditCtrl* comp);
};

#endif // __GWCCOLORCOMPONENTSET_H
